diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/test.py ns-3.41/test.py
--- ns-3.40/test.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/test.py	2024-02-09 14:44:08.629795300 -0800
@@ -2009,93 +2128,212 @@
         shutil.rmtree(testpy_output_dir)
 
     if passed_tests + skipped_tests == total_tests:
-        return 0 # success
+        return 0  # success
     else:
-        return 1 # catchall for general errors
+        return 1  # catchall for general errors
+
 
 def main(argv):
     parser = argparse.ArgumentParser()
-    parser.add_argument("-b", "--buildpath", action="store", type=str, default="",
-                        help="specify the path where ns-3 was built (defaults to the build directory for the current variant)")
-
-    parser.add_argument("-c", "--constrain", action="store", type=str, default="",
-                        help="constrain the test-runner by kind of test")
-
-    parser.add_argument("-d", "--duration", action="store_true", default=False,
-                        help="print the duration of each test suite and example")
-
-    parser.add_argument("-e", "--example", action="store", type=str, default="",
-                        help="specify a single example to run (no relative path is needed)")
-
-    parser.add_argument("-u", "--update-data", action="store_true", default=False,
-                        help="If examples use reference data files, get them to re-generate them")
-
-    parser.add_argument("-f", "--fullness", action="store", type=str, default="QUICK",
-                        choices=["QUICK", "EXTENSIVE", "TAKES_FOREVER"],
-                        help="choose the duration of tests to run: QUICK, EXTENSIVE, or TAKES_FOREVER, where EXTENSIVE includes QUICK and TAKES_FOREVER includes QUICK and EXTENSIVE (only QUICK tests are run by default)")
-
-    parser.add_argument("-g", "--grind", action="store_true", dest="valgrind", default=False,
-                        help="run the test suites and examples using valgrind")
-
-    parser.add_argument("-k", "--kinds", action="store_true", default=False,
-                        help="print the kinds of tests available")
-
-    parser.add_argument("-l", "--list", action="store_true", default=False,
-                        help="print the list of known tests")
-
-    parser.add_argument("-m", "--multiple", action="store_true", default=False,
-                        help="report multiple failures from test suites and test cases")
-
-    parser.add_argument("-n", "--no-build", action="store_true", default=False,
-                        help="do not build before starting testing")
-
-    parser.add_argument("-p", "--pyexample", action="store", type=str, default="",
-                        help="specify a single python example to run (with relative path)")
-
-    parser.add_argument("-r", "--retain", action="store_true", default=False,
-                        help="retain all temporary files (which are normally deleted)")
-
-    parser.add_argument("-s", "--suite", action="store", type=str, default="",
-                        help="specify a single test suite to run")
-
-    parser.add_argument("-t", "--text", action="store", type=str, default="",
-                        metavar="TEXT-FILE",
-                        help="write detailed test results into TEXT-FILE.txt")
-
-    parser.add_argument("-v", "--verbose", action="store_true", default=False,
-                        help="print progress and informational messages")
-
-    parser.add_argument("--verbose-failed", action="store_true", default=False,
-                        help="print progress and informational messages for failed jobs")
-
-    parser.add_argument("-w", "--web", "--html", action="store", type=str, dest="html", default="",
-                        metavar="HTML-FILE",
-                        help="write detailed test results into HTML-FILE.html")
-
-    parser.add_argument("-x", "--xml", action="store", type=str, default="",
-                        metavar="XML-FILE",
-                        help="write detailed test results into XML-FILE.xml")
-
-    parser.add_argument("--nocolor", action="store_true", default=False,
-                        help="do not use colors in the standard output")
-
-    parser.add_argument("--jobs", action="store", type=int, dest="process_limit", default=0,
-                        help="limit number of worker threads")
-
-    parser.add_argument("--rerun-failed", action="store_true", dest="rerun_failed", default=False,
-                        help="rerun failed tests")
+    parser.add_argument(
+        "-b",
+        "--buildpath",
+        action="store",
+        type=str,
+        default="",
+        help="specify the path where ns-3 was built (defaults to the build directory for the current variant)",
+    )
+
+    parser.add_argument(
+        "-c",
+        "--constrain",
+        action="store",
+        type=str,
+        default="",
+        help="constrain the test-runner by kind of test",
+    )
+
+    parser.add_argument(
+        "-d",
+        "--duration",
+        action="store_true",
+        default=False,
+        help="print the duration of each test suite and example",
+    )
+
+    parser.add_argument(
+        "-e",
+        "--example",
+        action="store",
+        type=str,
+        default="",
+        help="specify a single example to run (no relative path is needed)",
+    )
+
+    parser.add_argument(
+        "-u",
+        "--update-data",
+        action="store_true",
+        default=False,
+        help="If examples use reference data files, get them to re-generate them",
+    )
+
+    parser.add_argument(
+        "-f",
+        "--fullness",
+        action="store",
+        type=str,
+        default="QUICK",
+        choices=["QUICK", "EXTENSIVE", "TAKES_FOREVER"],
+        help="choose the duration of tests to run: QUICK, EXTENSIVE, or TAKES_FOREVER, where EXTENSIVE includes QUICK and TAKES_FOREVER includes QUICK and EXTENSIVE (only QUICK tests are run by default)",
+    )
+
+    parser.add_argument(
+        "-g",
+        "--grind",
+        action="store_true",
+        dest="valgrind",
+        default=False,
+        help="run the test suites and examples using valgrind",
+    )
+
+    parser.add_argument(
+        "-k",
+        "--kinds",
+        action="store_true",
+        default=False,
+        help="print the kinds of tests available",
+    )
+
+    parser.add_argument(
+        "-l", "--list", action="store_true", default=False, help="print the list of known tests"
+    )
+
+    parser.add_argument(
+        "-m",
+        "--multiple",
+        action="store_true",
+        default=False,
+        help="report multiple failures from test suites and test cases",
+    )
+
+    parser.add_argument(
+        "-n",
+        "--no-build",
+        action="store_true",
+        default=False,
+        help="do not build before starting testing",
+    )
+
+    parser.add_argument(
+        "-p",
+        "--pyexample",
+        action="store",
+        type=str,
+        default="",
+        help="specify a single python example to run (with relative path)",
+    )
+
+    parser.add_argument(
+        "-r",
+        "--retain",
+        action="store_true",
+        default=False,
+        help="retain all temporary files (which are normally deleted)",
+    )
+
+    parser.add_argument(
+        "-s",
+        "--suite",
+        action="store",
+        type=str,
+        default="",
+        help="specify a single test suite to run",
+    )
+
+    parser.add_argument(
+        "-t",
+        "--text",
+        action="store",
+        type=str,
+        default="",
+        metavar="TEXT-FILE",
+        help="write detailed test results into TEXT-FILE.txt",
+    )
+
+    parser.add_argument(
+        "-v",
+        "--verbose",
+        action="store_true",
+        default=False,
+        help="print progress and informational messages",
+    )
+
+    parser.add_argument(
+        "--verbose-failed",
+        action="store_true",
+        default=False,
+        help="print progress and informational messages for failed jobs",
+    )
+
+    parser.add_argument(
+        "-w",
+        "--web",
+        "--html",
+        action="store",
+        type=str,
+        dest="html",
+        default="",
+        metavar="HTML-FILE",
+        help="write detailed test results into HTML-FILE.html",
+    )
+
+    parser.add_argument(
+        "-x",
+        "--xml",
+        action="store",
+        type=str,
+        default="",
+        metavar="XML-FILE",
+        help="write detailed test results into XML-FILE.xml",
+    )
+
+    parser.add_argument(
+        "--nocolor",
+        action="store_true",
+        default=False,
+        help="do not use colors in the standard output",
+    )
+
+    parser.add_argument(
+        "--jobs",
+        action="store",
+        type=int,
+        dest="process_limit",
+        default=0,
+        help="limit number of worker threads",
+    )
+
+    parser.add_argument(
+        "--rerun-failed",
+        action="store_true",
+        dest="rerun_failed",
+        default=False,
+        help="rerun failed tests",
+    )
 
     global args
     args = parser.parse_args()
     signal.signal(signal.SIGINT, sigint_hook)
 
     # From waf/waflib/Options.py
-    envcolor = os.environ.get('NOCOLOR', '') and 'no' or 'auto' or 'yes'
+    envcolor = os.environ.get("NOCOLOR", "") and "no" or "auto" or "yes"
 
-    if args.nocolor or envcolor == 'no':
-        colors_lst['USE'] = False
+    if args.nocolor or envcolor == "no":
+        colors_lst["USE"] = False
 
     return run_tests()
 
-if __name__ == '__main__':
+
+if __name__ == "__main__":
     sys.exit(main(sys.argv))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/bench-scheduler.cc ns-3.41/utils/bench-scheduler.cc
--- ns-3.40/utils/bench-scheduler.cc	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/bench-scheduler.cc	2024-02-09 14:44:08.629795300 -0800
@@ -479,10 +479,10 @@
               "\n"
               "If no scheduler is specified the MapScheduler will be run.");
     cmd.AddValue("all", "use all schedulers", allSched);
-    cmd.AddValue("cal", "use CalendarSheduler", schedCal);
+    cmd.AddValue("cal", "use CalendarScheduler", schedCal);
     cmd.AddValue("calrev", "reverse ordering in the CalendarScheduler", calRev);
     cmd.AddValue("heap", "use HeapScheduler", schedHeap);
-    cmd.AddValue("list", "use ListSheduler", schedList);
+    cmd.AddValue("list", "use ListScheduler", schedList);
     cmd.AddValue("map", "use MapScheduler (default)", schedMap);
     cmd.AddValue("pri", "use PriorityQueue", schedPQ);
     cmd.AddValue("debug", "enable debugging output", g_debug);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/utils/check-style-clang-format.py ns-3.41/utils/check-style-clang-format.py
--- ns-3.40/utils/check-style-clang-format.py	2023-09-27 13:30:37.934840000 -0700
+++ ns-3.41/utils/check-style-clang-format.py	2024-02-09 14:44:08.629795300 -0800
@@ -18,7 +18,7 @@
 # Author: Eduardo Nuno Almeida <enmsa@outlook.pt> [INESC TEC and FEUP, Portugal]
 
 """
-Check and apply the ns-3 coding style to all files in the PATH argument.
+Check and apply the ns-3 coding style recursively to all files in the PATH arguments.
 
 The coding style is defined with the clang-format tool, whose definitions are in
 the ".clang-format" file. This script performs the following checks / fixes:
@@ -30,8 +30,8 @@
 This script can be applied to all text files in a given path or to individual files.
 
 NOTE: The formatting check requires clang-format (version >= 14) to be found on the path.
-Trimming of trailing whitespace and conversion of tabs to spaces (via the "--no-formatting"
-option) do not depend on clang-format.
+The remaining checks do not depend on clang-format and can be executed by disabling clang-format
+checking with the "--no-formatting" option.
 """
 
 import argparse
@@ -42,88 +42,88 @@
 import shutil
 import subprocess
 import sys
-
 from typing import Callable, Dict, List, Tuple
 
 ###########################################################
 # PARAMETERS
 ###########################################################
 CLANG_FORMAT_VERSIONS = [
+    17,
     16,
     15,
     14,
 ]
 
-CLANG_FORMAT_GUARD_ON = '// clang-format on'
-CLANG_FORMAT_GUARD_OFF = '// clang-format off'
+CLANG_FORMAT_GUARD_ON = "// clang-format on"
+CLANG_FORMAT_GUARD_OFF = "// clang-format off"
 
 DIRECTORIES_TO_SKIP = [
-    '__pycache__',
-    '.vscode',
-    'bindings',
-    'build',
-    'cmake-cache',
-    'testpy-output',
+    "__pycache__",
+    ".git",
+    "bindings",
+    "build",
+    "cmake-cache",
+    "testpy-output",
 ]
 
 # List of files entirely copied from elsewhere that should not be checked,
 # in order to optimize the performance of this script
 FILES_TO_SKIP = [
-    'valgrind.h',
+    "valgrind.h",
 ]
 
 FILE_EXTENSIONS_TO_CHECK_FORMATTING = [
-    '.c',
-    '.cc',
-    '.h',
+    ".c",
+    ".cc",
+    ".h",
 ]
 
 FILE_EXTENSIONS_TO_CHECK_INCLUDE_PREFIXES = FILE_EXTENSIONS_TO_CHECK_FORMATTING
 
 FILE_EXTENSIONS_TO_CHECK_WHITESPACE = [
-    '.c',
-    '.cc',
-    '.click',
-    '.cmake',
-    '.conf',
-    '.css',
-    '.dot',
-    '.gnuplot',
-    '.gp',
-    '.h',
-    '.html',
-    '.js',
-    '.json',
-    '.m',
-    '.md',
-    '.mob',
-    '.ns_params',
-    '.ns_movements',
-    '.params',
-    '.pl',
-    '.plt',
-    '.py',
-    '.rst',
-    '.seqdiag',
-    '.sh',
-    '.txt',
-    '.yml',
+    ".c",
+    ".cc",
+    ".click",
+    ".cmake",
+    ".conf",
+    ".css",
+    ".dot",
+    ".gnuplot",
+    ".gp",
+    ".h",
+    ".html",
+    ".js",
+    ".json",
+    ".m",
+    ".md",
+    ".mob",
+    ".ns_params",
+    ".ns_movements",
+    ".params",
+    ".pl",
+    ".plt",
+    ".py",
+    ".rst",
+    ".seqdiag",
+    ".sh",
+    ".txt",
+    ".yml",
 ]
 
 FILES_TO_CHECK_WHITESPACE = [
-    'Makefile',
-    'ns3',
+    "Makefile",
+    "ns3",
 ]
 
 FILE_EXTENSIONS_TO_CHECK_TABS = [
-    '.c',
-    '.cc',
-    '.h',
-    '.md',
-    '.py',
-    '.rst',
-    '.sh',
-    '.yml',
+    ".c",
+    ".cc",
+    ".h",
+    ".md",
+    ".py",
+    ".rst",
+    ".sh",
+    ".yml",
 ]
 TAB_SIZE = 4
 
@@ -141,14 +141,16 @@
 
     _, directory = os.path.split(dirpath)
 
-    return not (directory in DIRECTORIES_TO_SKIP or
-                (directory.startswith('.') and directory != '.'))
+    return not (
+        directory in DIRECTORIES_TO_SKIP or (directory.startswith(".") and directory != ".")
+    )
 
 
-def should_analyze_file(path: str,
-                        files_to_check: List[str],
-                        file_extensions_to_check: List[str],
-                        ) -> bool:
+def should_analyze_file(
+    path: str,
+    files_to_check: List[str],
+    file_extensions_to_check: List[str],
+) -> bool:
     """
     Check whether a file should be analyzed.
 
@@ -165,15 +167,16 @@
 
     basename, extension = os.path.splitext(filename)
 
-    return (basename in files_to_check or
-            extension in file_extensions_to_check)
+    return basename in files_to_check or extension in file_extensions_to_check
 
 
-def find_files_to_check_style(path: str) -> Tuple[List[str], List[str], List[str], List[str]]:
+def find_files_to_check_style(
+    paths: List[str],
+) -> Tuple[List[str], List[str], List[str], List[str]]:
     """
-    Find all files to be checked in a given path.
+    Find all files to be checked in a given list of paths.
 
-    @param path Path to check.
+    @param paths List of paths to the files to check.
     @return Tuple [List of files to check include prefixes,
                    List of files to check formatting,
                    List of files to check trailing whitespace,
@@ -181,22 +184,24 @@
     """
 
     files_to_check: List[str] = []
-    abs_path = os.path.abspath(os.path.expanduser(path))
 
-    if os.path.isfile(abs_path):
-        files_to_check = [path]
+    for path in paths:
+        abs_path = os.path.abspath(os.path.expanduser(path))
 
-    elif os.path.isdir(abs_path):
-        for dirpath, dirnames, filenames in os.walk(path, topdown=True):
-            if not should_analyze_directory(dirpath):
-                # Remove directory and its subdirectories
-                dirnames[:] = []
-                continue
+        if os.path.isfile(abs_path):
+            files_to_check.append(path)
 
-            files_to_check.extend([os.path.join(dirpath, f) for f in filenames])
+        elif os.path.isdir(abs_path):
+            for dirpath, dirnames, filenames in os.walk(path, topdown=True):
+                if not should_analyze_directory(dirpath):
+                    # Remove directory and its subdirectories
+                    dirnames[:] = []
+                    continue
 
-    else:
-        raise ValueError(f'Error: {path} is not a file nor a directory')
+                files_to_check.extend([os.path.join(dirpath, f) for f in filenames])
+
+        else:
+            raise ValueError(f"Error: {path} is not a file nor a directory")
 
     files_to_check.sort()
 
@@ -236,51 +241,52 @@
 
     # Find exact version
     for version in CLANG_FORMAT_VERSIONS:
-        clang_format_path = shutil.which(f'clang-format-{version}')
+        clang_format_path = shutil.which(f"clang-format-{version}")
 
         if clang_format_path:
             return clang_format_path
 
     # Find default version and check if it is supported
-    clang_format_path = shutil.which('clang-format')
+    clang_format_path = shutil.which("clang-format")
 
     if clang_format_path:
         process = subprocess.run(
-            [clang_format_path, '--version'],
+            [clang_format_path, "--version"],
             capture_output=True,
             text=True,
             check=True,
         )
 
-        version = process.stdout.strip().split(' ')[-1]
-        major_version = int(version.split('.')[0])
+        version = process.stdout.strip().split(" ")[-1]
+        major_version = int(version.split(".")[0])
 
         if major_version in CLANG_FORMAT_VERSIONS:
             return clang_format_path
 
     # No supported version of clang-format found
     raise RuntimeError(
-        f'Could not find any supported version of clang-format installed on this system. '
-        f'List of supported versions: {CLANG_FORMAT_VERSIONS}.'
+        f"Could not find any supported version of clang-format installed on this system. "
+        f"List of supported versions: {CLANG_FORMAT_VERSIONS}."
     )
 
 
 ###########################################################
 # CHECK STYLE MAIN FUNCTIONS
 ###########################################################
-def check_style_clang_format(path: str,
-                             enable_check_include_prefixes: bool,
-                             enable_check_formatting: bool,
-                             enable_check_whitespace: bool,
-                             enable_check_tabs: bool,
-                             fix: bool,
-                             verbose: bool,
-                             n_jobs: int = 1,
-                             ) -> bool:
+def check_style_clang_format(
+    paths: List[str],
+    enable_check_include_prefixes: bool,
+    enable_check_formatting: bool,
+    enable_check_whitespace: bool,
+    enable_check_tabs: bool,
+    fix: bool,
+    verbose: bool,
+    n_jobs: int = 1,
+) -> bool:
     """
     Check / fix the coding style of a list of files.
 
-    @param path Path to the files.
+    @param paths List of paths to the files to check.
     @param enable_check_include_prefixes Whether to enable checking #include headers from the same module with the "ns3/" prefix.
     @param enable_check_formatting Whether to enable checking code formatting.
     @param enable_check_whitespace Whether to enable checking trailing whitespace.
@@ -291,10 +297,12 @@
     @return Whether all files are compliant with all enabled style checks.
     """
 
-    (files_to_check_include_prefixes,
-     files_to_check_formatting,
-     files_to_check_whitespace,
-     files_to_check_tabs) = find_files_to_check_style(path)
+    (
+        files_to_check_include_prefixes,
+        files_to_check_formatting,
+        files_to_check_whitespace,
+        files_to_check_tabs,
+    ) = find_files_to_check_style(paths)
 
     check_include_prefixes_successful = True
     check_formatting_successful = True
@@ -302,74 +310,83 @@
     check_tabs_successful = True
 
     if enable_check_include_prefixes:
-        check_include_prefixes_successful = check_style_file(
-            files_to_check_include_prefixes,
-            check_include_prefixes_file,
+        check_include_prefixes_successful = check_style_files(
             '#include headers from the same module with the "ns3/" prefix',
+            check_manually_file,
+            files_to_check_include_prefixes,
             fix,
             verbose,
             n_jobs,
+            respect_clang_format_guards=True,
+            check_style_line_function=check_include_prefixes_line,
         )
 
-        print('')
+        print("")
 
     if enable_check_formatting:
-        check_formatting_successful = check_style_file(
-            files_to_check_formatting,
+        check_formatting_successful = check_style_files(
+            "bad code formatting",
             check_formatting_file,
-            'bad code formatting',
+            files_to_check_formatting,
             fix,
             verbose,
             n_jobs,
             clang_format_path=find_clang_format_path(),
         )
 
-        print('')
+        print("")
 
     if enable_check_whitespace:
-        check_whitespace_successful = check_style_file(
+        check_whitespace_successful = check_style_files(
+            "trailing whitespace",
+            check_manually_file,
             files_to_check_whitespace,
-            check_trailing_whitespace_file,
-            'trailing whitespace',
             fix,
             verbose,
             n_jobs,
+            respect_clang_format_guards=False,
+            check_style_line_function=check_whitespace_line,
         )
 
-        print('')
+        print("")
 
     if enable_check_tabs:
-        check_tabs_successful = check_style_file(
+        check_tabs_successful = check_style_files(
+            "tabs",
+            check_manually_file,
             files_to_check_tabs,
-            check_tabs_file,
-            'tabs',
             fix,
             verbose,
             n_jobs,
+            respect_clang_format_guards=True,
+            check_style_line_function=check_tabs_line,
         )
 
-    return all([
-        check_include_prefixes_successful,
-        check_formatting_successful,
-        check_whitespace_successful,
-        check_tabs_successful,
-    ])
-
-
-def check_style_file(filenames: List[str],
-                     check_style_file_function: Callable,
-                     style_check_str: str,
-                     fix: bool,
-                     verbose: bool,
-                     n_jobs: int,
-                     **kwargs,
-                     ) -> bool:
+    return all(
+        [
+            check_include_prefixes_successful,
+            check_formatting_successful,
+            check_whitespace_successful,
+            check_tabs_successful,
+        ]
+    )
+
+
+def check_style_files(
+    style_check_str: str,
+    check_style_file_function: Callable[..., Tuple[str, bool, List[str]]],
+    filenames: List[str],
+    fix: bool,
+    verbose: bool,
+    n_jobs: int,
+    **kwargs,
+) -> bool:
     """
     Check / fix style of a list of files.
 
-    @param filename Name of the file to be checked.
-    @param check_style_file_function Function used to check the file.
     @param style_check_str Description of the check to be performed.
+    @param check_style_file_function Function used to check the file.
+    @param filename Name of the file to be checked.
     @param fix Whether to fix (True) or just check (False) the file (True).
     @param verbose Show the lines that are not compliant with the style.
     @param n_jobs Number of parallel jobs.
@@ -390,7 +407,7 @@
             *[arg if isinstance(arg, list) else itertools.repeat(arg) for arg in kwargs.values()],
         )
 
-        for (filename, is_file_compliant, verbose_infos) in non_compliant_files_results:
+        for filename, is_file_compliant, verbose_infos in non_compliant_files_results:
             if not is_file_compliant:
                 non_compliant_files.append(filename)
 
@@ -399,22 +416,22 @@
 
     # Output results
     if not non_compliant_files:
-        print(f'- No files detected with {style_check_str}')
+        print(f"- No files detected with {style_check_str}")
         return True
 
     else:
         n_non_compliant_files = len(non_compliant_files)
 
         if fix:
-            print(f'- Fixed {style_check_str} in the files ({n_non_compliant_files}):')
+            print(f"- Fixed {style_check_str} in the files ({n_non_compliant_files}):")
         else:
-            print(f'- Detected {style_check_str} in the files ({n_non_compliant_files}):')
+            print(f"- Detected {style_check_str} in the files ({n_non_compliant_files}):")
 
         for f in non_compliant_files:
             if verbose:
-                print(*[f'    {l}' for l in files_verbose_infos[f]], sep='\n')
+                print(*[f"    {l}" for l in files_verbose_infos[f]], sep="\n")
             else:
-                print(f'    - {f}')
+                print(f"    - {f}")
 
         # If all files were fixed, there are no more non-compliant files
         return fix
@@ -423,86 +440,12 @@
 ###########################################################
 # CHECK STYLE FUNCTIONS
 ###########################################################
-def check_include_prefixes_file(filename: str,
-                                fix: bool,
-                                verbose: bool,
-                                ) -> Tuple[str, bool, List[str]]:
-    """
-    Check / fix #include headers from the same module with the "ns3/" prefix in a file.
-
-    @param filename Name of the file to be checked.
-    @param fix Whether to fix (True) or just check (False) the style of the file (True).
-    @param verbose Show the lines that are not compliant with the style.
-    @return Tuple [Filename,
-                   Whether the file is compliant with the style (before the check),
-                   Verbose information].
-    """
-
-    is_file_compliant = True
-    clang_format_enabled = True
-
-    verbose_infos: List[str] = []
-
-    with open(filename, 'r', encoding='utf-8') as f:
-        file_lines = f.readlines()
-
-    for (i, line) in enumerate(file_lines):
-
-        # Check clang-format guards
-        line_stripped = line.strip()
-
-        if line_stripped == CLANG_FORMAT_GUARD_ON:
-            clang_format_enabled = True
-        elif line_stripped == CLANG_FORMAT_GUARD_OFF:
-            clang_format_enabled = False
-
-        if (not clang_format_enabled and
-                line_stripped not in (CLANG_FORMAT_GUARD_ON, CLANG_FORMAT_GUARD_OFF)):
-            continue
-
-        # Check if the line is an #include and extract its header file
-        header_file = re.findall(r'^#include ["<]ns3/(.*\.h)[">]', line_stripped)
-
-        if not header_file:
-            continue
-
-        # Check if the header file belongs to the same module and remove the "ns3/" prefix
-        header_file = header_file[0]
-        parent_path = os.path.split(filename)[0]
-
-        if not os.path.exists(os.path.join(parent_path, header_file)):
-            continue
-
-        is_file_compliant = False
-        file_lines[i] = line_stripped.replace(
-            f'ns3/{header_file}', header_file).replace('<', '"').replace('>', '"') + '\n'
-
-        if verbose:
-            header_index = len('#include "')
-
-            verbose_infos.extend([
-                f'{filename}:{i + 1}:{header_index + 1}: error: #include headers from the same module with the "ns3/" prefix detected',
-                f'    {line_stripped}',
-                f'    {"":{header_index}}^',
-            ])
-
-        # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not compliant
-        if not fix and not verbose:
-            break
-
-    # Update file with the fixed lines
-    if fix and not is_file_compliant:
-        with open(filename, 'w', encoding='utf-8') as f:
-            f.writelines(file_lines)
-
-    return (filename, is_file_compliant, verbose_infos)
-
-
-def check_formatting_file(filename: str,
-                          fix: bool,
-                          verbose: bool,
-                          clang_format_path: str,
-                          ) -> Tuple[str, bool, List[str]]:
+def check_formatting_file(
+    filename: str,
+    fix: bool,
+    verbose: bool,
+    clang_format_path: str,
+) -> Tuple[str, bool, List[str]]:
     """
     Check / fix the coding style of a file with clang-format.
 
@@ -522,18 +465,18 @@
         [
             clang_format_path,
             filename,
-            '-style=file',
-            '--dry-run',
-            '--Werror',
+            "-style=file",
+            "--dry-run",
+            "--Werror",
             # Optimization: In non-verbose mode, only one error is needed to check that the file is not compliant
-            f'--ferror-limit={0 if verbose else 1}',
+            f"--ferror-limit={0 if verbose else 1}",
         ],
         check=False,
         capture_output=True,
         text=True,
     )
 
-    is_file_compliant = (process.returncode == 0)
+    is_file_compliant = process.returncode == 0
 
     if verbose:
         verbose_infos = process.stderr.splitlines()
@@ -544,8 +487,8 @@
             [
                 clang_format_path,
                 filename,
-                '-style=file',
-                '-i',
+                "-style=file",
+                "-i",
             ],
             check=False,
             stdout=subprocess.DEVNULL,
@@ -555,16 +498,21 @@
     return (filename, is_file_compliant, verbose_infos)
 
 
-def check_trailing_whitespace_file(filename: str,
-                                   fix: bool,
-                                   verbose: bool,
-                                   ) -> Tuple[str, bool, List[str]]:
+def check_manually_file(
+    filename: str,
+    fix: bool,
+    verbose: bool,
+    respect_clang_format_guards: bool,
+    check_style_line_function: Callable[[str, str, int], Tuple[bool, str, List[str]]],
+) -> Tuple[str, bool, List[str]]:
     """
-    Check / fix trailing whitespace in a file.
+    Check / fix a file manually using a function to check / fix each line.
 
     @param filename Name of the file to be checked.
     @param fix Whether to fix (True) or just check (False) the style of the file (True).
     @param verbose Show the lines that are not compliant with the style.
+    @param respect_clang_format_guards Whether to respect clang-format guards.
+    @param check_style_line_function Function used to check each line.
     @return Tuple [Filename,
                    Whether the file is compliant with the style (before the check),
                    Verbose information].
